Subject: Re: [PATCH v3 00/10] midx: stop duplicating info redundant with their sources

From: Patrick Steinhardt <[email-masked]>
Date: Tue, 2 Sep 2025 08:36:08 +0200

On Sat, Aug 30, 2025 at 09:39:02AM -0400, Derrick Stolee wrote:
> On 8/28/25 8:34 PM, Taylor Blau wrote:
> > On Thu, Aug 28, 2025 at 03:46:35PM -0700, Junio C Hamano wrote:
> > > Patrick Steinhardt <[email-masked]> writes:
> > > 
> > > > Changes in v2:
> > > >    - Fix a comment typo.
> > > >    - Introduce another commit that simplifies the calling convention for
> > > >      `link_alt_odb_entry()`.
> > > >    - Link to v1: https://lore.kernel.org/r/[email-masked]
> > > > 
> > > > Changes in v3:
> > > >    - Introduce `odb_find_source_or_die()` so that we don't have to repeat
> > > >      the calls to `die()`, as suggested by Taylor.
> > > >    - Split out a patch to adapt `link_alt_odb_entry()` and friends to
> > > >      consistently name the parameter that refers to the alternate object
> > > >      directory's path.
> > > >    - Link to v2: https://lore.kernel.org/r/[email-masked]
> > > 
> > > This has gone quiet even though the previous two iterations got
> > > fairly detailed review.  Should we declare victory and mark the
> > > topic for 'next' now?
> > 
> > No objections from me; though I still would feel a little better with
> > Stolee's opinion on the MIDX --object-dir stuff.
> 
> Sorry I had missed this series and in particular how it handles the
> --object-dir option.
> 
> I think the modification to add structure to the --object-dir option
> by passing around an object source is going to make things better.
> 
> The one thing I was very careful about was that we are not trying
> to create a full "repository" struct based on the object-dir, because
> there may not be one! We only know that there is an alternate object
> database where we want to break the norm and perform writes. The
> changes here make that seem like it continues to work.

Yup, this should continue to work as-is indeed. We also have a couple of
tests in t5319 which verify that this works alright. And overall I think
the whole logic becomes a bit easier to reason about now that we pass
around the object source explicitly.

Thanks for your thoughts. With that I'm happy to have this series merged
down to 'next'.

Patrick